
#include "SCB_Optimization_Core0.h"


extern mdma_counter0 ;
extern mdma_counter1 ;
extern mdma_counter2 ;
extern mdma_counter3;


#ifdef SDRAM
section("sdram0_bank1")
#else
#ifdef  L2
section("L2_sram")
#else L1
section("L1_data_a")
#endif
#endif
unsigned char Tx_BUFF[MAX_SIZE];



#ifdef SDRAM
section("sdram0_bank2")
#else
#ifdef  L2
section("L2_sram_uncached")
#else L1
section("L1_data_b")
#endif
#endif
unsigned char  Rx_BUFF[MAX_SIZE];

/*

#pragma align 32

#ifdef SDRAM
section("sdram0_bank0") unsigned char Tx_BUFF[MAX_SIZE];
section("sdram0_bank0") unsigned char Rx_BUFF[MAX_SIZE];
#else
#ifdef  L2
section("l2_sram") unsigned char ucIntSrcBuff0[MAX_SIZE];
section("l2_sram") unsigned char ucIntDestBuff0[MAX_SIZE];
#else L1
section("L1_data_a") unsigned char ucIntSrcBuff0[MAX_SIZE];
section("L1_data_a") unsigned char ucIntDestBuff0[MAX_SIZE];
#endif
#endif
*/


/*****************************************************************************/

void Init_Tx_BUFF(void);
void Init_Interrupts(void);
void Init_SRC_MDMA(void);
void Init_DEST_MDMA(void);
void Enable_MDMA(void);
void Disable_MDMA(void);
void DEST_MDMA_Handler0 (uint32_t iid, void *handlerArg);
void DEST_MDMA_Handler1 (uint32_t iid, void *handlerArg);
void DEST_MDMA_Handler2 (uint32_t iid, void *handlerArg);
void DEST_MDMA_Handler3 (uint32_t iid, void *handlerArg);
/*****************************************************************************/

int mdma_init(void)
{
	Init_Tx_BUFF();
	Init_Interrupts();
	Init_SRC_MDMA();
	Init_DEST_MDMA();
	return 0;
}
/*****************************************************************************/

void Init_Tx_BUFF(void)
{
	int count;
	for (count=0; count<BUFF_SIZE; count++)
		Tx_BUFF[count] = rand();
}
/*****************************************************************************/

void Init_Interrupts(void)
{
	*pREG_SEC0_GCTL	 = ENUM_SEC_GCTL_EN;
	*pREG_SEC0_CCTL0 = ENUM_SEC_CCTL_EN;
	adi_int_InstallHandler(INTR_MDMA0_DST, DEST_MDMA_Handler0, 0, true);
	adi_int_InstallHandler(INTR_MDMA1_DST, DEST_MDMA_Handler1, 0, true);
	adi_int_InstallHandler(INTR_MDMA2_DST, DEST_MDMA_Handler2, 0, true);
	adi_int_InstallHandler(INTR_MDMA3_DST, DEST_MDMA_Handler3, 0, true);
}

void DEST_MDMA_Handler0 (uint32_t iid, void *handlerArg)
{
//	while (!(*pREG_DMA22_STAT & ENUM_DMA_STAT_IRQDONE));
	*pREG_DMA22_STAT |= ENUM_DMA_STAT_IRQDONE ;
    ssync();
	mdma_counter0++ ;
}

void DEST_MDMA_Handler1 (uint32_t iid, void *handlerArg)
{
//	while (!(*pREG_DMA24_STAT & ENUM_DMA_STAT_IRQDONE));
	*pREG_DMA24_STAT |= ENUM_DMA_STAT_IRQDONE ;
    ssync();
	mdma_counter1++ ;
}

void DEST_MDMA_Handler2 (uint32_t iid, void *handlerArg)
{
//	while (!(*pREG_DMA26_STAT & ENUM_DMA_STAT_IRQDONE));
	*pREG_DMA26_STAT |= ENUM_DMA_STAT_IRQDONE ;
    ssync();
	mdma_counter2++ ;
}

void DEST_MDMA_Handler3 (uint32_t iid, void *handlerArg)
{
//	while (!(*pREG_DMA28_STAT & ENUM_DMA_STAT_IRQDONE));
	*pREG_DMA28_STAT |= ENUM_DMA_STAT_IRQDONE ;
    ssync();
	mdma_counter3++ ;
}


/*****************************************************************************/

void Init_SRC_MDMA(void)
{
	/* configure source registers */
	*pREG_DMA21_CFG 	= (ENUM_DMA_CFG_READ | ENUM_DMA_CFG_MSIZE32| ENUM_DMA_CFG_PSIZE04 | ENUM_DMA_CFG_XCNT_INT |  ENUM_DMA_CFG_ADDR1D |ENUM_DMA_CFG_AUTO);
	*pREG_DMA21_ADDRSTART= Tx_BUFF;
	*pREG_DMA21_XCNT 	= BUFF_SIZE/32;
	*pREG_DMA21_XMOD 	= 32;

	/* configure source registers */
	*pREG_DMA23_CFG 	= (ENUM_DMA_CFG_READ | ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE04 | ENUM_DMA_CFG_XCNT_INT |  ENUM_DMA_CFG_ADDR1D |ENUM_DMA_CFG_AUTO);
	*pREG_DMA23_ADDRSTART= Tx_BUFF;
	*pREG_DMA23_XCNT 	= BUFF_SIZE/32;
	*pREG_DMA23_XMOD 	= 32;

	/* configure source registers */
	*pREG_DMA25_CFG 	= (ENUM_DMA_CFG_READ | ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE04 | ENUM_DMA_CFG_XCNT_INT |  ENUM_DMA_CFG_ADDR1D |ENUM_DMA_CFG_AUTO);
	*pREG_DMA25_ADDRSTART= Tx_BUFF;
	*pREG_DMA25_XCNT 	= BUFF_SIZE/32;
	*pREG_DMA25_XMOD 	= 32;

	/* configure source registers */
	*pREG_DMA27_CFG 	= (ENUM_DMA_CFG_READ | ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE04 | ENUM_DMA_CFG_XCNT_INT |  ENUM_DMA_CFG_ADDR1D |ENUM_DMA_CFG_AUTO);
	*pREG_DMA27_ADDRSTART= Tx_BUFF;
	*pREG_DMA27_XCNT 	= BUFF_SIZE/32;
	*pREG_DMA27_XMOD 	= 32;


}

void Init_DEST_MDMA(void)
{
	/* configure destination registers */
	*pREG_DMA22_CFG 	= (ENUM_DMA_CFG_WRITE | ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE04 | ENUM_DMA_CFG_XCNT_INT | ENUM_DMA_CFG_ADDR1D| ENUM_DMA_CFG_AUTO);
	*pREG_DMA22_ADDRSTART= Rx_BUFF;
	*pREG_DMA22_XCNT 	= BUFF_SIZE/32;
	*pREG_DMA22_XMOD 	= 32;

	/* configure destination registers */
	*pREG_DMA24_CFG 	= (ENUM_DMA_CFG_WRITE | ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE04 | ENUM_DMA_CFG_XCNT_INT | ENUM_DMA_CFG_ADDR1D| ENUM_DMA_CFG_AUTO);
	*pREG_DMA24_ADDRSTART= Rx_BUFF;
	*pREG_DMA24_XCNT 	= BUFF_SIZE/32;
	*pREG_DMA24_XMOD 	= 32;

	/* configure destination registers */
	*pREG_DMA26_CFG 	= (ENUM_DMA_CFG_WRITE | ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE04 | ENUM_DMA_CFG_XCNT_INT | ENUM_DMA_CFG_ADDR1D| ENUM_DMA_CFG_AUTO);
	*pREG_DMA26_ADDRSTART= Rx_BUFF;
	*pREG_DMA26_XCNT 	= BUFF_SIZE/32;
	*pREG_DMA26_XMOD 	= 32;

	/* configure destination registers */
	*pREG_DMA28_CFG 	= (ENUM_DMA_CFG_WRITE | ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE04 | ENUM_DMA_CFG_XCNT_INT | ENUM_DMA_CFG_ADDR1D| ENUM_DMA_CFG_AUTO);
	*pREG_DMA28_ADDRSTART= Rx_BUFF;
	*pREG_DMA28_XCNT 	= BUFF_SIZE/32;
	*pREG_DMA28_XMOD 	= 32;

}

