/*
 * timer.c
 *
 *  Created on: Jul 16, 2013
 *      Author: AAgarwal2
 */


#include <ccblkfn.h>
#include "adi_initialize.h"
#include "SCB_Optimization_Core0.h"


// CCLK 500 Mhz = 2ns
// For 1 sec timeout = 500 *10^6
#define TIMEOUT_PERIOD  500000000

extern bool done;

void timerIrqHandler(uint32_t iid, void* handlerArg)
{
	// Complete the test case
	done = false;

	/* disable DMA */
	*pREG_DMA21_CFG 	= 0;
	*pREG_DMA22_CFG 	= 0;
	/* disable DMA */
	*pREG_DMA23_CFG 	= 0;
	*pREG_DMA24_CFG 	= 0;
	/* disable DMA */
	*pREG_DMA25_CFG 	= 0;
	*pREG_DMA26_CFG 	= 0;
	/* disable DMA */
	*pREG_DMA27_CFG 	= 0;
	*pREG_DMA28_CFG 	= 0;

}


int timer_init(void)
{
	/* Begin adding your custom code here */

	// Timer Configuration
	*pTCNTL |=   BITM_TCNTL_PWR | BITM_TCNTL_INT ;
	*pTPERIOD = TIMEOUT_PERIOD;

	// Enable Global Control Register
	*pREG_SEC0_GCTL = ENUM_SEC_GCTL_EN;
	*pREG_SEC0_CCTL0= ENUM_SEC_CCTL_EN;

	// Register handler
	adi_int_InstallHandler(ADI_CID_IVTMR,timerIrqHandler,NULL,true);

	return 0;
}

